/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.deken.game.sprites;

import org.deken.game.animation.Animation;
import org.deken.game.animation.StaticAnimationStrip;
import org.deken.game.motion.Motion;
import org.deken.game.movement.Movement;

/**
 *
 * @author Gary Deken
 */
public class BaseActor extends Actor {

   public BaseActor(SpriteSize size) {
      super(size);
   }

   /**
    * BaseActor
    *
    * @param motion Motion
    * @param movement Movement
    * @param size SpriteSize
    */
   public BaseActor(Motion motion, Movement movement, SpriteSize size) {
      this(motion, movement, size, new StaticAnimationStrip(motion.getImage()));
   }

   /**
    * BaseActor
    *
    * @param motion Motion
    * @param movement Movement
    * @param size SpriteSize
    * @param stillAnimation Animation
    */
   public BaseActor(Motion motion, Movement movement, SpriteSize size,
      Animation stillAnimation) {
      this(motion, 1, movement, size, stillAnimation);
   }

   public BaseActor(Motion motion, int numberOfMotions, Movement movement,
      SpriteSize size, Animation stillAnimation) {
      super(motion, numberOfMotions, movement, size, stillAnimation);
   }

   public BaseActor(Motion stillMotion, int numberOfMotions, Movement movement,
      SpriteSize size) {
      super(stillMotion, numberOfMotions, movement, size);
   }

   @Override
   protected void spriteCollison(Sprite collideSprite) {
      // Do nothing.
   }

   /**
    * clone
    * @return Object
    */
   public Object clone() {
      BaseActor newActor = new BaseActor((SpriteSize) this.getSize().clone());
      newActor = (BaseActor) super.cloneBase(newActor);
      return newActor;
   }

}
