package org.deken.game.sprites;

/**
 * <p>Title: SpriteSize</p>
 *
 * <p>Description: Stores a size (measurement) of a sprite.</p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * @author Gary Deken
 * @version 1.0
 */
public class SpriteSize implements Cloneable {
   private int height = 0;
   private int width = 0;
   private int depth = 0;

   /**
    * SpriteSize Constructors.
    */
   public SpriteSize() {
   }

   /**
    * SpriteSize
    *
    * @param newHeight int
    * @param newWidth int
    * @param newDepth int
    */
   public SpriteSize(int newHeight, int newWidth, int newDepth) {
      height = newHeight;
      width = newWidth;
      depth = newDepth;
   }

   /**
    * SpriteSize
    *
    * @param newHeight int
    * @param newWidth int
    */
   public SpriteSize(int newHeight, int newWidth) {
      height = newHeight;
      width = newWidth;
   }

   /**
    * Get the size height.
    *
    * @return int
    */
   public int getHeight() {
      return height;
   }

   /**
    * Get the size width.
    *
    * @return int
    */
   public int getWidth() {
      return width;
   }

   /**
    * Get the size depth.
    *
    * @return int
    */
   public int getDepth() {
      return depth;
   }

   @Override
   public String toString() {
      StringBuilder str = new StringBuilder("SpriteSize: height: ");
      str.append(height).append(" width: ").append(width);
      str.append(" depth: ").append(depth);
      return str.toString();
   }

   /**
    * clone
    * Copies this sprite size
    *
    * @return SpriteSize
    */
   @Override
   public Object clone() {
      SpriteSize newSize = new SpriteSize(this.height, this.width, this.depth);
      return newSize;
   }
}
